local U = UnitIsUnit;
local GetNamePlate = C_NamePlate.GetNamePlateForUnit;
local frame = CreateFrame("frame");
local data = {};

function NamePlate_Added(...)
   local nameplateId = ...;
   local nameplate = GetNamePlate(nameplateId).UnitFrame;

   for i=1,5 do
      if UnitIsUnit(nameplateId, "arena"..i) then
         addIcon(data[i], nameplate);
      end
   end
end

function NamePlate_Removed(...)
   local nameplateId = ...;
   local nameplate = GetNamePlate(nameplateId).UnitFrame;

   if (nameplate.iconClass) then
      nameplate.iconClass:Hide();
   end
end

function SetupIcons()
   for i = 1, GetNumArenaOpponentSpecs() do
      local specID = GetArenaOpponentSpec(i)
      if specID > 0 then
         local id, name, description, icon, role, class = GetSpecializationInfoByID(specID);
         data[i] = icon;
      end
   end
end

function addIcon (icon, frame)
   local button = CreateFrame("Button", "ClassIcon", frame);
   local txt = button:CreateTexture();

   txt:SetTexture(icon);
   txt:SetAllPoints();
   
   button:SetNormalTexture(txt);
   button:SetWidth(30);
   button:SetHeight(30);
   button:SetPoint("CENTER", math.random(-5,5), 30);

   frame.iconClass = button;
end

frame:RegisterEvent('NAME_PLATE_UNIT_ADDED');
frame:RegisterEvent('NAME_PLATE_UNIT_REMOVED');
frame:RegisterEvent('ARENA_PREP_OPPONENT_SPECIALIZATIONS');
frame:SetScript('OnEvent', function (self, event, ...)
      if (event == "ARENA_PREP_OPPONENT_SPECIALIZATIONS") then
         SetupIcons();
      elseif (event == 'NAME_PLATE_UNIT_ADDED') then
         NamePlate_Added(...)
      elseif (event == 'NAME_PLATE_UNIT_REMOVED') then
         NamePlate_Removed(...);
      end
end)